with Ada.Text_IO; use Ada.Text_IO;
with System.Garlic.Priorities;
with Calculadora;
--  ###(I)###########################################################
--  FSF  ---------------------------------------------------------
with Ada.Real_Time;
with Rt_Glade_Scheduling;
with Rt_Glade_Scheduling.Priorities;
with Kernel_Console;
with Ada.Exceptions;
with Event_Id_Attributes_Set_Get;
--  ###(E)###########################################################

with System.OS_Interface;
pragma Elaborate_All (System.OS_Interface);

procedure Menu is
   Resultado_Suma : Integer := 20;
   Opp1, Opp2 : Integer := 0;
--  ###(I)###########################################################
--  FSF  ---------------------------------------------------------
   R_Message_Params : Rt_Glade_Scheduling.Message_Scheduling_Parameters_Ref;
   RTEP_Message_Params : Rt_Glade_Scheduling.Priorities
     .Priorities_Message_Scheduling_Parameters;

   RTEP_Net : constant := 2;
--  ###(E)###########################################################
begin
   Kernel_Console.Put ("Comienzo del cliente...");
   delay 1.0;

   Event_Id_Attributes_Set_Get.Set_Event_Id (12);
   Kernel_Console.Put (">1");

--  ###(I)###########################################################
--  FSF  ---------------------------------------------------------
     -- Initial Values to Priorities Params variables
--     FSF_Message_Params.Bytes_To_Transmit := 1000;
--     FSF_Message_Params.Period_Max := Ada.Real_Time.To_Time_Span (1.500);
--     FSF_Message_Params.Priority :=  12;

   RTEP_Message_Params.Outgoing_Priority := 12;


   Kernel_Console.Put (">2");
   -- Assign the Priorities Params variables values
   -- to the Rt_Glade_Scheduling Ref variables
   Rt_Glade_Scheduling.To_Message_Params_Ref
     (RTEP_Message_Params, R_Message_Params);

   Kernel_Console.Put (">3");
   -- Create_Send_Message_Handler
   Rt_Glade_Scheduling.Create_Send_Message_Handler
     (R_Message_Params.all,  -- Message Params
      2,         -- Node
      RTEP_Net,  -- Net
      2,         -- Port
      12);       -- Event_Id
   Put (">4");

   -- Create_RPC_Handler
   Rt_Glade_Scheduling.Create_Return_Message_Handler
     (RTEP_Net,  -- Net
      2,         -- Port
      12);       -- Event_Id
   Kernel_Console.Put (">5");
--  ###(E)###########################################################

   delay (2.0); -- Time to create endpoints in the other partition

   Kernel_Console.Put ("Comienzo");
   loop
      begin
         Opp1 :=  1;
         Opp2 :=  1;
         Resultado_Suma := Calculadora.Sumar (Opp1, Opp2);
         Kernel_Console.Put ("Sum := "&Resultado_Suma'Img);
         delay (1.0);
      exception
--  ===(I)====================================================
--  RT-GLADE =================================================
      when The_Error : others =>
         Kernel_Console.New_Line; Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     ## EXCEPTION  menu.adb     ##");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     "
                               & Ada.Exceptions.Exception_Name (The_Error));
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     "
                               & Ada.Exceptions.Exception_Message (The_Error));
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
--  ===(E)====================================================
         exit;
      end;
   end loop;
end Menu;
