--  with Fsf;
--  with Fsf.Implementation_Specific;
--  with Fsf.Shared_Objects;
with Rt_Glade_Scheduling;
with Rt_Glade_Scheduling.Priorities;
with Ada.Text_IO; use Ada.Text_IO;
with Kernel_Console;
with Ada.Exceptions;
with Ada.Real_Time;
procedure P1_Init_Code is
   R_Task_Params : Rt_Glade_Scheduling.Task_Scheduling_Parameters_Ref;
   R_Message_Params : Rt_Glade_Scheduling.Message_Scheduling_Parameters_Ref;

   RTEP_Task_Params : Rt_Glade_Scheduling.Priorities
     .Priorities_Task_Scheduling_Parameters;
   RTEP_Message_Params : Rt_Glade_Scheduling.Priorities
     .Priorities_Message_Scheduling_Parameters;

   RTEP_Net : constant := 2;

--     procedure Evito_Error_De_Bloqueo is
--        Task_Contract : Fsf.Contract_Parameters;
--        Sched_Server : Fsf.Server_Id;
--     begin
--        --  Contract
--        Task_Contract := Fsf.Initialize;
--
--        --  Parameters
--        Fsf.Set_Contract_Basic_Parameters
--          (Task_Contract,
--           Ada.Real_Time.To_Time_Span (0.100),
--           Ada.Real_Time.To_Time_Span (5.000),
--           Fsf.Indeterminate);
--
--        Fsf.Implementation_Specific.Set_Contract_Preemption_Level
--          (Task_Contract,
--           19);
--
--        Fsf.Negotiate_Contract_For_Myself
--          (Task_Contract,
--           Sched_Server);
--     end Evito_Error_De_Bloqueo;

begin

   Kernel_Console.Put (">1");
   -- Initial Values to Priorities Params variables
--     FSF_Message_Params.Bytes_To_Transmit := 1000;
--     FSF_Message_Params.Period_Max := Ada.Real_Time.To_Time_Span (1.250);
--     FSF_Message_Params.Priority :=  17;

   RTEP_Message_Params.Outgoing_Priority := 17;

--     FSF_Task_Params.Budget_Min := Ada.Real_Time.To_Time_Span (0.500);
--     FSF_Task_Params.Period_Max := Ada.Real_Time.To_Time_Span (1.500);
--     FSF_Task_Params.Priority := 14;
--     FSF_Task_Params.Critical_Sections.Num := 0;

   RTEP_Task_Params.RPC_Handler_Priority := 14;
   Kernel_Console.Put (">2");

   -- Assign the Priorities Params variables values
   -- to the Rt_Glade_Scheduling Ref variables
   Rt_Glade_Scheduling.To_Task_Params_Ref
     (RTEP_Task_Params, R_Task_Params);
   Rt_Glade_Scheduling.To_Message_Params_Ref
     (RTEP_Message_Params, R_Message_Params);
   Kernel_Console.Put (">3");


   -- Create_Send_Message_Handler
   Rt_Glade_Scheduling.Create_Send_Message_Handler
     (R_Message_Params.all,  -- Message Params
      1, --  Node
      RTEP_Net,  -- Net
      2,  -- Port
      12);  --  Event_Id
   Kernel_Console.Put (">4");

   -- Create_RPC_Handler
   Rt_Glade_Scheduling.Create_RPC_Handler
     (R_Task_Params.all,  -- Task Params
      RTEP_Net,  -- Net
      2,  -- Port
      12);  --  Event_Id
   Kernel_Console.Put (">5");

--  ===(I)====================================================
--  RT-GLADE =================================================
exception
      when The_Error : others =>
         Kernel_Console.New_Line; Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     ## EXCEPTION  p1_init_code.adb     ##");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     "
                               & Ada.Exceptions.Exception_Name (The_Error));
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     "
                               & Ada.Exceptions.Exception_Message (The_Error));
         Kernel_Console.New_Line;
         Kernel_Console.Put ("     #######################################");
         Kernel_Console.New_Line;
--  ===(E)====================================================
end P1_Init_Code;
